/**
 * Created by wupeng5 on 2018/1/7.
 */
/**
 * ajax 处理类，
 * get: return promise
 * post: return promise
 * all: params:PromiseArray, return promise
 * 接口返回格式{code:0,message:"xx",data:object}
 * code:200, 成功, 其他为失败
 * code:701，未登录
 * code失败的情况下，打印message
 * return promise
 * 
 * 组件内部请求ajax必须继承此类extends:AjaxUtil
 * 
 **/

let param = function(obj) {
    var query = '';
    var name, value, fullSubName, subName, subValue, innerObj, i;

    for (name in obj) {
        value = obj[name];

        if (value instanceof Array) {
            for (i = 0; i < value.length; ++i) {
                subValue = value[i];
                fullSubName = name + '[' + i + ']';
                innerObj = {};
                innerObj[fullSubName] = subValue;
                query += param(innerObj) + '&';
            }
        } else if (value instanceof Object) {
            for (subName in value) {
                subValue = value[subName];
                fullSubName = name + '[' + subName + ']';
                innerObj = {};
                innerObj[fullSubName] = subValue;
                query += param(innerObj) + '&';
            }
        } else if (value !== undefined && value !== null) {
            query += encodeURIComponent(name) + '='
            + encodeURIComponent(value) + '&';
        }
    }

    return query.length ? query.substr(0, query.length - 1) : query;
};

import Q from "q";
// export default {
//     name: "AjaxUtil",
//     methods:{
//         getFetch(url){
//             let symbol = url.indexOf('?') == -1?"?":"&";
//             url = url + symbol + "ran="+Math.ceil(Math.random()*10000000);
//             let defer = Q.defer();
//             let headers = {
//                 'Content-Type': 'application/json; charset=UTF-8'
//             };
//             let options = {
//                 method:"get",
//                 credentials:'include',
//                 headers:headers
//             };
//             let that = this;
//             fetch(url,options).then(d =>d.json()).then(function (data) {
//                 let code = data.code;
//                 if(code == "701"){
//                     that.$router.push({path:"login"});
//                 }else{
//                     if(code == "200"){
//                         defer.resolve({data:data.data,params:data.params});
//                     }else{
//                         defer.reject({data: data.message});
//                     }
//                 }
//             }).catch(function(err) {
//                 defer.reject({data: "Server Error!"});
//                 throw new Error(url + " request server error!");
//             });
//             return defer.promise;
//         },
//         postFetch(url,data){
//             let symbol = url.indexOf('?') == -1?"?":"&";
//             url = url + symbol + "ran="+Math.ceil(Math.random()*10000000);
//             let defer = Q.defer();
//             let headers = {
//                 // 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'
//                 'Content-Type': 'application/json; charset=UTF-8'
//             };
//             let options = {
//                 method:"post",
//                 credentials:'include',
//                 headers:headers
//             };
//             if(data){
//                 // options.body = param(data);
//                 options.body = JSON.stringify(data);
//             }
//             let that = this;
//             fetch(url,options).then(d =>d.json()).then(function (data) {
//                 let code = data.code;
//                 if(code == "701"){
//                     that.$router.push({path:"login"});
//                 }else{                
//                     if(code == "200"){
//                         defer.resolve({data:data.data,params:data.params});
//                     }else{
//                         defer.reject({data: data.message});
//                     } 
//                 }
//             }).catch(function(err) {
//                 defer.reject({data: "Server Error!"});
//                 throw new Error(url + " request server error!");
//             });
//             return defer.promise;
//         },
//         uploadFetch(url,data){
//             let symbol = url.indexOf('?') == -1?"?":"&";
//             url = url + symbol + "ran="+Math.ceil(Math.random()*10000000);
            
//             let defer = Q.defer();
            
//             let options = {
//                 method:"post",
//                 credentials:'include'
//             };
//             if(data){
//                 options.body = data;
//             }
            
//             let that = this;      
//             fetch(url,options).then(d =>d.json()).then(function (data) {  
//                 let code = data.code;
//                 if(code == "701"){
//                     that.$router.push({path:"login"});
//                 }else{      
//                     if(code == "200"){
//                         defer.resolve({data:data.data,params:data.params});
//                     }else{
//                         defer.reject({data: data.message});
//                     } 
//                 }
//             }).catch(function(err) {
//                 defer.reject({data: "Server Error!"});
//                 throw new Error(url + " request server error!");
//             });
//             return defer.promise;
//         },
//         fetchAll(promises){
//             return Q.all(promises);
//         }
//     },
// };

export default {
    install:function(Vue){
        Vue.prototype.getFetch=function(url){
            let symbol = url.indexOf('?') == -1?"?":"&";
            url = url + symbol + "ran="+Math.ceil(Math.random()*10000000);
            let defer = Q.defer();
            let headers = {
                'Content-Type': 'application/json; charset=UTF-8'
            };
            let options = {
                method:"get",
                credentials:'include',
                headers:headers
            };
            let that = this;
            fetch(url,options).then(d =>d.json()).then( (data)=> {
                let code = data.code;
                if(code == "701"){
                    that.$router.push({path:"/login"});
                }else{
                    if(code == "200"){
                        defer.resolve({data:data.data,params:data.params});
                    }else{
                        defer.reject({data: data.message});
                    }
                }
            }).catch((err)=> {
                defer.reject({data: "Server Error!"});
                // this.showAlertMsg("error","服务器异常");
                throw new Error(url + " request server error!");
            });
            return defer.promise;
        };
        Vue.prototype.postFetch = function(url,data){
            let symbol = url.indexOf('?') == -1?"?":"&";
            url = url + symbol + "ran="+Math.ceil(Math.random()*10000000);
            let defer = Q.defer();
            let headers = {
                // 'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8'
                'Content-Type': 'application/json; charset=UTF-8',
            };
            let options = {
                method:"post",
                credentials:'include',
                headers:headers
            };
            if(data){
                // options.body = param(data);
                options.body = JSON.stringify(data);
            }
            let that = this;
            fetch(url,options).then(d =>d.json()).then((data)=> {
                let code = data.code;
                if(code == "701"){
                    that.$router.push({path:"/login"});
                }else{                
                    if(code == "200"){
                        defer.resolve({data:data.data,params:data.params});
                    }else{
                        defer.reject({data: data.message});
                    } 
                }
            }).catch(function(err) {
                defer.reject({data: "Server Error!"});
                throw new Error(url + " request server error!");
            });
            return defer.promise;
        };
        Vue.prototype.uploadFetch = function(url,data){
            let symbol = url.indexOf('?') == -1?"?":"&";
            url = url + symbol + "ran="+Math.ceil(Math.random()*10000000);
            
            let defer = Q.defer();
            
            let options = {
                method:"post",
                credentials:'include'
            };
            if(data){
                options.body = data;
            }
            
            let that = this;      
            fetch(url,options).then(d =>d.json()).then( (data)=> {  
                let code = data.code;
                if(code == "701"){
                    that.$router.push({path:"/login"});
                }else{      
                    if(code == "200"){
                        defer.resolve({data:data.data,params:data.params});
                        this.$Message.success(data.message);
                    }else{
                        defer.reject({data: data.message});
                    } 
                }
            }).catch(function(err) {
                defer.reject({data: "Server Error!"});
                // this.showAlertMsg("error","服务器异常");
                throw new Error(url + " request server error!");
            });
            return defer.promise;
        },
        Vue.prototype.fetchAll = (promises)=>{
            return Q.all(promises);
        }
    }
}