// The Vue build version to load with the `import` command
// (runtime-only or standalone) has been set in webpack.base.conf with an alias.
import Vue from 'vue';
import Vuex from 'vuex';
import App from './App.vue';
import router from './router/index.js';

import ElementUI from 'element-ui'; //引入js
import 'element-ui/lib/theme-chalk/index.css';//引入css

import AlertMsg from "./core/tool/alert.js";
import AjaxService from "./core/tool/ajaxService.js";

import store from "./store/index.js";
import BaiduMap from 'vue-baidu-map'

import 'babel-polyfill'
Vue.use(BaiduMap, {
  // ak 是在百度地图开发者平台申请的密钥 详见 http://lbsyun.baidu.com/apiconsole/key */
  ak: '9iFIaYXhOfi4CpSBP0xKYOBCBOGEWH0A'
})

Vue.use(Vuex);
Vue.use(ElementUI);
Vue.use(AlertMsg);
Vue.use(AjaxService);

/* eslint-disable no-new */
new Vue({
  el: '#app',
  router,
  store,
  components: { App },
  template: '<App/>'
})
