import Vue from 'vue';
import Router from 'vue-router';
import Vuex from 'vuex';

import AuthHOC from "../components/authHOC/authHoc.js";
import Input from "../components/input.vue";
//布局&登录
import Layout from "../components/layout/layout.vue";
import Login from '../components/login/login.vue';

Vue.use(Router);
Vue.use(Vuex);

export default new Router({
    // mode:"history",
    routes: [
        {
            path: '/',
            name: 'login',
            component: Login
        },
        {
            path: '/login',
            name: 'login1',
            component: Login
        },
        {
            path: '/layout',
            name: 'Layout',
            component: AuthHOC(Layout),
            children: [
                {
                    path: '/input',
                    name: 'Input',
                    component: Input
                },
                //首页
                {
                    path: '/',
                    name: 'HomePage',
                    component: r => require.ensure([], () => r(require('../components/layout/homePage.vue')), 'HomePage')
                },
                //服务器配置
                {
                    path: '/basicSettings',
                    name: 'basicSettings',
                    component: r => require.ensure([], () => r(require('../components/basicSettings/list.vue')), 'basicSettings')
                },
                // 草稿
                {
                    path: '/draft',
                    name: 'draft',
                    component: r => require.ensure([], () => r(require('../components/draft/list.vue')), 'draft')
                },
                //code提交列表
                {
                    path: '/codesubmit',
                    name: 'codesubmit',
                    component: r => require.ensure([], () => r(require('../components/codesubmit/list.vue')), 'codesubmit')
                },
                //审核
                {
                    path: '/audit',
                    name: 'audit',
                    component: r => require.ensure([], () => r(require('../components/audit/list.vue')), 'audit')
                },
                // 发布
                {
                    path: '/release',
                    name: 'release',
                    component: r => require.ensure([], () => r(require('../components/release/list.vue')), 'release')
                },
                // 成员管理
                {
                    path: '/member',
                    name: 'member',
                    component: r => require.ensure([], () => r(require('../components/member/list.vue')), 'member')
                },
                // 抖音poi 
                {
                    path: '/ttpoiList',
                    name: 'ttpoiList',
                    component: r => require.ensure([], () => r(require('../components/ttpoiList/list.vue')), 'ttpoiList')
                },
                // 抖音poi添加资质
                {
                    path: '/addCertification',
                    name: 'addCertification',
                    component: r => require.ensure([], () => r(require('../components/ttpoiList/addCertification.vue')), 'addCertification')
                },
               
            ]
        },

    ]
})
